/*
 *  SH95UPD v0.0.6
 *
 *  KernelEX
 *  Copyright (C) 2006-2007, Xeno86
 *
 *  This file is part of KernelEx source code.
 *
 *  KernelEx is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published
 *  by the Free Software Foundation; version 2 of the License.
 *
 *  KernelEx is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "pefile.h"
#include "patch.h"

//---------------------------------------------------------------------------
//SHExitWindowsEx implementation
// Generated by GenPatch v1.01 by Xeno86
// source file: SHExitWindowsEx.c
static char PI_SHExitWindowsEx_code[] = {
	0x55,0x57,0x56,0x53,0x8b,0x7c,0x24,0x1c,0x8a,0x07,0x31,0xed,0x31,0xf6,0x31,0xdb,0x31,0xc9,0x84,0xc0,
	0x0f,0x84,0xa5,0x00,0x00,0x00,0x41,0x43,0x80,0x3c,0x39,0x00,0x75,0xf8,0x31,0xc9,0x84,0xc0,0x0f,0x84,
	0x93,0x00,0x00,0x00,0x8a,0x04,0x39,0x3c,0x30,0x75,0x04,0x31,0xf6,0xeb,0x61,0x3c,0x31,0x75,0x07,0xbe,
	0x01,0x00,0x00,0x00,0xeb,0x56,0x3c,0x32,0x75,0x07,0xbe,0x02,0x00,0x00,0x00,0xeb,0x4b,0x3c,0x33,0x75,
	0x07,0xbe,0x03,0x00,0x00,0x00,0xeb,0x40,0x3c,0x34,0x75,0x07,0xbe,0x04,0x00,0x00,0x00,0xeb,0x35,0x3c,
	0x35,0x75,0x07,0xbe,0x05,0x00,0x00,0x00,0xeb,0x2a,0x3c,0x36,0x75,0x07,0xbe,0x06,0x00,0x00,0x00,0xeb,
	0x1f,0x3c,0x37,0x75,0x07,0xbe,0x07,0x00,0x00,0x00,0xeb,0x14,0x3c,0x38,0x75,0x07,0xbe,0x08,0x00,0x00,
	0x00,0xeb,0x09,0x3c,0x39,0x75,0x05,0xbe,0x09,0x00,0x00,0x00,0x31,0xd2,0x83,0xfb,0x01,0x76,0x13,0x85,
	0xf6,0x74,0x0f,0x8d,0x43,0xff,0x39,0xc2,0x73,0x08,0x89,0xc2,0x6b,0xf6,0x0a,0x4a,0x75,0xfa,0x41,0x01,
	0xf5,0x4b,0x80,0x3c,0x39,0x00,0xe9,0x67,0xff,0xff,0xff,0xff,0x74,0x24,0x14,0xff,0x15,0xc3,0x00,0x00,
	0x00,0x6a,0x00,0x55,0xff,0x15,0xcc,0x00,0x00,0x00,0x5b,0x5e,0x5f,0xb8,0x10,0x00,0x00,0x00,0x5d,0xc2,
	0x10,0x00,
};  //code size = 0xde (222)
static api_entry PI_SHExitWindowsEx_abs[] = {
	{ 0xc5, "user32.DestroyWindow" },
	{ 0xce, "user32.ExitWindowsEx" },
	{ 0, "" },
};
static api_entry PI_SHExitWindowsEx_hook[] = {
	{ 0x00, "SHExitWindowsEx" },
	{ 0, "" },
};
static patch_item PI_SHExitWindowsEx(PI_SHExitWindowsEx_code, sizeof(PI_SHExitWindowsEx_code), NULL, PI_SHExitWindowsEx_abs, NULL, PI_SHExitWindowsEx_hook, NULL);

//---------------------------------------------------------------------------
//DllGetVersion implementation
// Generated by GenPatch v1.01 by Xeno86
// source file: DllGetVersion.c
static char PI_DllGetVersion_code[] = {
	0x8b,0x54,0x24,0x04,0x83,0x3a,0x00,0xb8,0x57,0x00,0x07,0x80,0x74,0x1e,0xc7,0x42,0x04,0x04,0x00,0x00,
	0x00,0xc7,0x42,0x08,0x48,0x00,0x00,0x00,0xc7,0x42,0x0c,0x1c,0x0e,0x00,0x00,0xc7,0x42,0x10,0x01,0x00,
	0x00,0x00,0x31,0xc0,0xc2,0x04,0x00,
};  //code size = 0x2f (47)
static api_entry PI_DllGetVersion_hook[] = {
	{ 0x00, "DllGetVersion" },
	{ 0, "" },
};
static patch_item PI_DllGetVersion(PI_DllGetVersion_code, sizeof(PI_DllGetVersion_code), NULL, NULL, NULL, PI_DllGetVersion_hook, NULL);

//---------------------------------------------------------------------------
//DllCanUnloadNow implementation
// Generated by GenPatch v1.01 by Xeno86
// source file: DllCanUnloadNow.c
static char PI_DllCanUnloadNow_code[] = {
	0xb8,0x01,0x00,0x00,0x00,0xc3,
};  //code size = 0x6 (6)
static api_entry PI_DllCanUnloadNow_hook[] = {
	{ 0x00, "DllCanUnloadNow" },
	{ 0, "" },
};
static patch_item PI_DllCanUnloadNow(PI_DllCanUnloadNow_code, sizeof(PI_DllCanUnloadNow_code), NULL, NULL, NULL, PI_DllCanUnloadNow_hook, NULL);

//---------------------------------------------------------------------------
//DllInstall implementation
// Generated by GenPatch v1.01 by Xeno86
// source file: DllInstall.c
static char PI_DllInstall_code[] = {
	0x31,0xc0,0xc3,
};  //code size = 0x3 (3)
static api_entry PI_DllInstall_hook[] = {
	{ 0x00, "DllInstall" },
	{ 0, "" },
};
static patch_item PI_DllInstall(PI_DllInstall_code, sizeof(PI_DllInstall_code), NULL, NULL, NULL, PI_DllInstall_hook, NULL);

//---------------------------------------------------------------------------
//DllRegisterServer implementation
// Generated by GenPatch v1.01 by Xeno86
// source file: DllRegisterServer.c
static char PI_DllRegisterServer_code[] = {
	0x31,0xc0,0xc3,
};  //code size = 0x3 (3)
static api_entry PI_DllRegisterServer_hook[] = {
	{ 0x00, "DllRegisterServer" },
	{ 0, "" },
};
/* class patch_item001 : public patch_item
{
private:

public:
    patch_item001(char * bc, int s, DWORD aofs[], api_entry aapi[], api_entry rapi[], api_entry hapi[], int (* cstm)()) : patch_item(bc, s, aofs, aapi, rapi, hapi, cstm) {}
    int Process(DWORD Rva, char * ptr)
    {
	DWORD *ExportPtr;
	DWORD RVAPtr;

	RVAPtr=Destination->GetApiExportNameRVA("RealShellExecuteExA");
	ExportPtr=(DWORD *)Destination->RvaToOffset(RVAPtr);

	memcpy(ExportPtr,"SHCreatePropShe",16);

	RVAPtr=Destination->GetApiExportNameRVA("RealShellExecuteExA_temp");
	ExportPtr=(DWORD *)Destination->RvaToOffset(RVAPtr);

	memcpy(ExportPtr,"RealShellExecuteExA",21);

        return patch_item::Process(Rva, ptr);
    }
}
static PI_DllRegisterServer(PI_DllRegisterServer_code, sizeof(PI_DllRegisterServer_code), NULL, NULL, NULL, PI_DllRegisterServer_hook, NULL);
*/
static patch_item PI_DllRegisterServer(PI_DllRegisterServer_code, sizeof(PI_DllRegisterServer_code), NULL, NULL, NULL, PI_DllRegisterServer_hook, NULL);

//---------------------------------------------------------------------------
//DllUnregisterServer implementation
// Generated by GenPatch v1.01 by Xeno86
// source file: DllUnregisterServer.c
static char PI_DllUnregisterServer_code[] = {
	0x31,0xc0,0xc3,
};  //code size = 0x3 (3)
static api_entry PI_DllUnregisterServer_hook[] = {
	{ 0x00, "DllUnregisterServer" },
	{ 0, "" },
};
static patch_item PI_DllUnregisterServer(PI_DllUnregisterServer_code, sizeof(PI_DllUnregisterServer_code), NULL, NULL, NULL, PI_DllUnregisterServer_hook, NULL);

//---------------------------------------------------------------------------
//Aliases
static patch_item_alias PI_SHGetSpecialFolderPathA("SHGetSpecialFolderPathA","Ordinal175");
static patch_item_alias PI_SHGetSpecialFolderPathW("SHGetSpecialFolderPathW","Ordinal175");
static patch_item_alias PI_SHGetNewLinkInfo("SHGetNewLinkInfo","Ordinal179");
static patch_item_alias PI_SHGetPathFromIDListW("SHGetPathFromIDListW","SHGetPathFromIDListA");
static patch_item_alias PI_SHGetFileInfoW("SHGetFileInfoW","SHGetFileInfoA");
static patch_item_alias PI_SHGetDataFromIDListW("SHGetDataFromIDListW","SHGetDataFromIDListA");
/* static patch_item_alias PI_RealShellExecuteExA_temp("RealShellExecuteExA_temp","RealShellExecuteExA"); */

//---------------------------------------------------------------------------
// UPDATE PROCEDURE
//---------------------------------------------------------------------------
static patch_item * patches[] = {
/* Win95 shell */
	&PI_SHGetSpecialFolderPathA,
	&PI_SHGetSpecialFolderPathW,
	&PI_SHGetNewLinkInfo,
	&PI_SHExitWindowsEx,
	&PI_SHGetPathFromIDListW,
	&PI_SHGetFileInfoW,
	&PI_DllInstall,
	&PI_DllGetVersion,
	&PI_DllCanUnloadNow,
	&PI_SHGetDataFromIDListW,
	/* &PI_RealShellExecuteExA_temp,*/ /* Save the address of Ordinal194 under a different name */
	/* &PI_RealShellExecuteExA,*/ /* SHCreatePropSheetExtArrayEx replacement as Ordinal 194 */
	&PI_DllRegisterServer, /* Also renames RealShellExecuteExA and RealShellExecuteExA_temp while patching */
	&PI_DllUnregisterServer,

	NULL,
};

int shell32_updt(CPEFile & File2Patch)
{
	patch_item ** target_patches = patches;

	File2Patch.RemoveDebug();
	return apply_patches(File2Patch, target_patches);
}
