#include <shlwapi.h>

/* MAKE_EXPORT DllGetVersion=DllGetVersion */
/***********************************************************************
* DllGetVersion
*
* Retrieve "shell32.dll" version information.
*
* PARAMS
*     pdvi[O] pointer to version information structure.
*
* RETURNS
*     Success: S_OK. pdvi is updated with the version information
*     Failure: E_INVALIDARG, if pdvi->cbSize is not set correctly.
*
* NOTES
*     You may pass either a DLLVERSIONINFO structure
*     as pdvi, provided that the size is set correctly.
*     Returns version as shell32.dll version 4.0.1214
*/
HRESULT WINAPI DllGetVersion (DLLVERSIONINFO *pdvi) {

    if(!pdvi->cbSize) return E_INVALIDARG;
    pdvi->dwMajorVersion=4;
    pdvi->dwMinorVersion=72;
    pdvi->dwBuildNumber=3612;
    pdvi->dwPlatformID=DLLVER_PLATFORM_WINDOWS;
    return S_OK;	
}
