/*
 *  SH95UPD v0.0.6
 *
 *  KernelEx
 *  Copyright (C) 2006-2007, Xeno86
 *
 *  This file is part of KernelEx source code.
 *
 *  KernelEx is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published
 *  by the Free Software Foundation; version 2 of the License.
 *
 *  KernelEx is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/** @file common.h
 * Common declarations and definitions.
 */

#ifndef __COMMON_H
#define __COMMON_H

/** SH95UPD version. */
//no whitespace here!
#define VERSION "0.0.6"

/** Version info for RC file. */
#define RCVERSION 0,0,6,0

#include "vrprintf.h"

/** Space to allocate for patches (per file). */
#define PATCH_MAX_SIZE  0x100000
/** Name of section in PE file. */
#define UPDT_SEC_NAME "SH95UPD"

#define PATCH_OK       0
#define PATCH_FAIL     1

#define MINOR_W98      10
#define MINOR_WME      90

// bit patterns for get_cmdline_params() function
#define CMD_REMOVE     0x00000001
#define CMD_REINSTALL  0x00000002
#define CMD_BATCH      0x00000004

/** A macro that checks if a file exists. */
#define FileExists(x) (GetFileAttributes(x) != 0xffffffff && !(GetFileAttributes(x) & FILE_ATTRIBUTE_DIRECTORY))

#ifdef __cplusplus
int get_cmdline_params(void);
void PushError(const char *msg, int error_code = 0);
int MessageBox(const char *txt, unsigned int type);
#endif

extern unsigned long MinorVersion;

#endif // __COMMON_H
