/*
 *  KernelEx
 *  Copyright (C) 2007, Xeno86
 *
 *  Original WIN98UPDT0001
 *  Copyright (C) 2005/2006, (x)
 *
 *  This file is part of KernelEx source code.
 *
 *  KernelEx is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published
 *  by the Free Software Foundation; version 2 of the License.
 *
 *  KernelEx is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/** @file file.h
 * Class CFile - declaration.
 */

#ifndef __FILE_H
#define __FILE_H

#include <stdio.h>
#include <stdlib.h>

/** @class CFile
 * Class providing basic operations on files.
 */
class CFile
{

protected:
    void*  m_Buffer;         /**< Buffer. */
    int m_BufferLen;         /**< Buffer length. */
    int m_MaxBufferLen;      /**< Size of loaded file + number of bytes reserved. */

public:
    CFile();
    ~CFile();

    bool LoadFromFile( const char* FilePath, int SizeToAdd=0 );
    bool SaveToFile( const char* FilePath );

    bool LoadFromFile( const char* FilePath, void* Buffer, int BufferLen );
    bool SaveToFile( const char* FilePath, void* Buffer, int BufferLen );

    int GetFileSize( const char* FilePath );
    int GetOriginalLen( const char* FilePath );
    int GetBufferLen();

    bool SetBufferLen(int NewSize);

    void* GetBuffer();
};

#endif
